############################################################################
#                                                                          #
#  Copyright (c) 2001, 2022 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
sub NXClusterTools::generateClusterGUID{package NXClusterTools;no warnings;(my (
@command)=());push (@command,$GLOBAL::COMMAND_NXKEYGEN);push (@command,
"\x2d\x75");(my (@options)=());push (@options,"\x73\x65\x74\x20\x65\x6e\x76",(((
"\x4c\x44\x5f\x4c\x49\x42\x52\x41\x52\x59\x5f\x50\x41\x54\x48\x3d".
$GLOBAL::NODE_ROOT).$GLOBAL::DIRECTORY_SLASH)."\x6c\x69\x62"));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x53\x59\x53\x54\x45\x4d\x3d".
$GLOBAL::NODE_ROOT));(my $homeDir=NXPaths::getUserNXHomeDir ());push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x48\x4f\x4d\x45\x3d".$homeDir));(my ($cmdErr,
$cmdOut,$exitValue)=main::nxRunCommand ((\@command),(\@options)));if ((
$exitValue!=(0x0897+ 3963-0x1812))){Logger::warning (
"\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x6e\x65\x72\x61\x74\x65\x20\x67\x75\x69\x64\x20\x6b\x65\x79\x2e"
);return ((""));}chomp ($cmdOut);return ($cmdOut);}sub 
NXClusterTools::generateClusterKeys{package NXClusterTools;no warnings;(my (
@command)=());push (@command,$GLOBAL::COMMAND_NXKEYGEN);(my $priv=
NXPaths::getClusterRSAPrivateKey ());(my $pub=NXPaths::getClusterRSAPublicKey ()
);push (@command,"\x2d\x6b",$priv);push (@command,"\x2d\x70",$pub);push (
@command,"\x2d\x74","\x72\x73\x61");(my (@options)=());push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",(((
"\x4c\x44\x5f\x4c\x49\x42\x52\x41\x52\x59\x5f\x50\x41\x54\x48\x3d".
$GLOBAL::NODE_ROOT).$GLOBAL::DIRECTORY_SLASH)."\x6c\x69\x62"));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x53\x59\x53\x54\x45\x4d\x3d".
$GLOBAL::NODE_ROOT));(my $homeDir=NXPaths::getUserNXHomeDir ());push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x48\x4f\x4d\x45\x3d".$homeDir));(my ($cmd_err,
$cmd_out,$exit_value)=main::nxRunCommand ((\@command),(\@options)));
changeFileOwnershipToNxIfRoot ($priv);changeFileOwnershipToNxIfRoot ($pub);if ((
Common::NXFile::setPermissionsReadWriteForNX ($priv)==(-(0x00e0+ 5436-0x161b))))
{Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x74\x6f\x20"
.$priv)."\x2e"));}if ((
Common::NXFile::setPermissionReadWriteForOwnerReadOnlyForAll ($pub)==(-
(0x02f0+ 5743-0x195e)))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x74\x6f\x20"
.$pub)."\x2e"));}}sub NXClusterTools::generateClusterHostCerts{package 
NXClusterTools;no warnings;(my (@command)=());push (@command,
$GLOBAL::COMMAND_NXKEYGEN);(my $priv=NXPaths::getClustetHostPrivateCert ());(my $pub
=NXPaths::getClusterHostPublicCert ());push (@command,"\x2d\x6b",$priv);push (
@command,"\x2d\x63",$pub);(my (@options)=());push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",(((
"\x4c\x44\x5f\x4c\x49\x42\x52\x41\x52\x59\x5f\x50\x41\x54\x48\x3d".
$GLOBAL::NODE_ROOT).$GLOBAL::DIRECTORY_SLASH)."\x6c\x69\x62"));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x53\x59\x53\x54\x45\x4d\x3d".
$GLOBAL::NODE_ROOT));(my $homeDir=NXPaths::getUserNXHomeDir ());push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x48\x4f\x4d\x45\x3d".$homeDir));(my ($cmd_err,
$cmd_out,$exit_value)=main::nxRunCommand ((\@command),(\@options)));
changeFileOwnershipToNxIfRoot ($priv);changeFileOwnershipToNxIfRoot ($pub);if ((
Common::NXFile::setPermissionsReadWriteForNX ($priv)==(-(0x0955+ 3507-0x1707))))
{Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x74\x6f\x20"
.$priv)."\x2e"));}if ((
Common::NXFile::setPermissionReadWriteForOwnerReadOnlyForAll ($pub)==(-
(0x01d1+ 6680-0x1be8)))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x74\x6f\x20"
.$pub)."\x2e"));}}sub NXClusterTools::__ipTakeover{package NXClusterTools;no 
warnings;($GLOBAL::ClusterOldLocal=NXCluster::getMyIP ());
NXCluster::setInterfaceAndMask ();(my $interface=$GLOBAL::ClusterInterface);(my $mask
=$GLOBAL::ClusterNetmask);(my (@command)=());sub BEGIN{require NXTools;do{
"\x4e\x58\x54\x6f\x6f\x6c\x73"->import};}push (@command,
NXTools::getUnixCommandPath ("\x69\x66\x63\x6f\x6e\x66\x69\x67"));push (@command
,$interface);push (@command,$GLOBAL::ClusterHost);push (@command,
"\x6e\x65\x74\x6d\x61\x73\x6b",$mask);(my (@options)=());(my ($cmdOut,$cmdErr,
$exitValue)=main::nxRunCommand ((\@command),(\@options)));Logger::debug (((((((
"\x63\x6d\x64\x4f\x75\x74\x20\x5b".$cmdOut).
"\x5d\x20\x63\x6d\x64\x45\x72\x72\x20\x5b").$cmdErr).
"\x5d\x20\x65\x78\x69\x74\x56\x61\x6c\x75\x65\x20\x5b").$exitValue)."\x5d"));if 
(($exitValue!=(0x1db5+ 767-0x20b4))){Logger::error ((((((
"\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x63\x72\x65\x61\x74\x65\x20\x61\x6c\x69\x61\x73\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20"
.$interface)."\x20\x66\x6f\x72\x20\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x20").
$cmdOut)."\x20").$cmdErr));}saveInterfaceToFile ($interface);(my $return=
libnxhs::NXNetworkTakeoverIP ($GLOBAL::ClusterHost));Logger::debug (((((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x54\x61\x6b\x65\x6f\x76\x65\x72\x49\x50\x28"
.$GLOBAL::ClusterHost)."\x29\x20\x5b").$return)."\x5d"));if (($return!=
(0x0cf1+ 1380-0x1255))){Logger::error (((
"\x4e\x65\x74\x77\x6f\x72\x6b\x20\x74\x61\x6b\x65\x6f\x76\x65\x72\x20\x66\x6f\x72\x20\x49\x50\x20"
.$GLOBAL::ClusterHost).
"\x20\x66\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x73\x74\x61\x72\x74\x2e"));}return
 ($exitValue);}sub NXClusterTools::cleanInterface{package NXClusterTools;no 
warnings;(my $interface=$GLOBAL::ClusterInterface);chomp ($interface);unless (
defined ($interface)){Logger::warning (
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x6c\x65\x61\x6e\x20\x63\x6c\x75\x73\x74\x65\x72\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x3a\x20\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x6e\x6f\x74\x20\x64\x65\x66\x69\x6e\x65\x64\x2e"
);return ((0x10e1+ 5453-0x262d));}(my (%interfaces)=getInterfaces ());if ((
$interfaces{$interface}eq (""))){Logger::debug (((
"\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x20".$interface).
"\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x63\x6c\x65\x61\x6e\x20\x75\x70\x2e"));(
$interface=__readInterfaceFromFile ());chomp ($interface);if (($interfaces{
$interface}eq (""))){Logger::debug (((
"\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27".$interface).
"\x27\x20\x66\x72\x6f\x6d\x20\x66\x69\x6c\x65\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x63\x6c\x65\x61\x6e\x20\x75\x70\x2e"
));return ((0x137f+ 1033-0x1788));}}(my (@command)=());push (@command,
NXTools::getUnixCommandPath ("\x69\x66\x63\x6f\x6e\x66\x69\x67"));push (@command
,$interface);push (@command,"\x64\x6f\x77\x6e");(my (@options)=());sub BEGIN{
require NXTools;do{"\x4e\x58\x54\x6f\x6f\x6c\x73"->import};}(my ($cmdOut,$cmdErr
,$exitValue)=main::nxRunCommand ((\@command),(\@options)));Logger::debug (((((((
"\x63\x6d\x64\x4f\x75\x74\x20\x27".$cmdOut).
"\x27\x20\x63\x6d\x64\x45\x72\x72\x20\x27").$cmdErr).
"\x27\x20\x65\x78\x69\x74\x56\x61\x6c\x75\x65\x20\x27").$exitValue)."\x27\x2e"))
;if (($exitValue!=(0x2630+ 128-0x26b0))){Logger::error (((((
"\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x64\x65\x6c\x65\x74\x65\x20\x61\x6c\x69\x61\x73\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27"
.$interface).
"\x27\x2e\x20\x45\x78\x69\x74\x20\x76\x61\x6c\x75\x65\x20\x69\x73\x20\x27").
$exitValue)."\x27\x2e"));}return ($exitValue);}sub 
NXClusterTools::saveInterfaceToFile{package NXClusterTools;no warnings;(my $interface
=shift (@_));(my $filename=(((($GLOBAL::VAR_ROOT.$GLOBAL::DIRECTORY_SLASH).
"\x72\x75\x6e").$GLOBAL::DIRECTORY_SLASH).
"\x6e\x78\x63\x6c\x75\x73\x74\x65\x72\x2e\x69\x6e\x74\x65\x72\x66\x61\x63\x65"))
;(my $fileExisted=(0x1cd4+ 247-0x1dcb));if (Common::NXFile::isExists ($filename)
){($fileExisted=(0x0e98+ 5388-0x23a3));}(my $FH=main::nxopen ($filename,(
$NXBits::O_RDWR+$NXBits::O_CREAT),(($NXBits::OthersRead+$NXBits::UserReadWrite)+
$NXBits::GroupRead)));if ((not (defined ($FH)))){(my $errorNumber=
libnxh::NXGetError ());(my $errorstring=libnxh::NXGetErrorString ());
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20".$filename
)."\x20\x66\x6f\x72\x20\x77\x72\x69\x74\x69\x6e\x67\x2e"));Logger::error (((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x20".$errorNumber)."\x2c\x20").$errorstring).
"\x2e"));return ((0x103b+ 1072-0x146a));}if ((main::nxwrite ($FH,($interface.
"\x0a"))==(-(0x052d+ 3883-0x1457)))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20\x27"
.$filename)."\x27\x2e"));main::nxclose ($FH);if ((not ($fileExisted))){
changeFileOwnershipToNxIfRoot ($filename);}return ((0x1aab+ 2322-0x23bc));}
main::nxclose ($FH);if ((not ($fileExisted))){changeFileOwnershipToNxIfRoot (
$filename);}return ((0x19c7+ 2576-0x23d7));}sub 
NXClusterTools::__readInterfaceFromFile{package NXClusterTools;no warnings;(my $filename
=(((($GLOBAL::VAR_ROOT.$GLOBAL::DIRECTORY_SLASH)."\x72\x75\x6e").
$GLOBAL::DIRECTORY_SLASH).
"\x6e\x78\x63\x6c\x75\x73\x74\x65\x72\x2e\x69\x6e\x74\x65\x72\x66\x61\x63\x65"))
;if ((not (Common::NXFile::isExists ($filename)))){Logger::debug (((
"\x46\x69\x6c\x65\x20".$filename).
"\x20\x64\x6f\x65\x73\x20\x6e\x6f\x74\x20\x65\x78\x69\x73\x74\x2e"));return (
(0x0dfc+ 230-0x0ee1));}(my $FH=main::nxopen ($filename,$NXBits::O_RDONLY,
(0x0091+ 5611-0x167c)));if ((not (defined ($FH)))){(my $errorNumber=
libnxh::NXGetError ());(my $errorstring=libnxh::NXGetErrorString ());
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20".$filename
)."\x20\x66\x6f\x72\x20\x72\x65\x61\x64\x69\x6e\x67\x2e"));Logger::error (((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20".$errorNumber)."\x2c\x20").
$errorstring)."\x2e"));return ((0x0158+ 3423-0x0eb7));}my ($interface);
main::nxreadLine ($FH,(\$interface));main::nxclose ($FH);return ($interface);}
sub NXClusterTools::getInterfaces{package NXClusterTools;no warnings;(my (
%interfaces)=());Logger::debug (
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x47\x65\x74\x4e\x65\x74\x77\x6f\x72\x6b\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x73"
);(my $return=libnxh::NXGetNetworkInterfaces ());Logger::debug (((
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x47\x65\x74\x4e\x65\x74\x77\x6f\x72\x6b\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x73\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$return)."\x27\x2e"));(my (@lines)=split ( /\n/ ,$return,(0x1ac2+ 762-0x1dbc)))
;foreach my $line (@lines){if (($line=~ /(^[\w:\d]+)\s+AF_INET\s+([0-9A-Fa-f]{2}[:-]){5}([0-9A-Fa-f]{2})+\s+(\d+\.\d+\.\d+\.\d+)\s+(\d+\.\d+\.\d+\.\d+)/ )
){Logger::debug ((((((("\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27".$1).
"\x27\x2c\x20\x49\x50\x20\x27").$4)."\x27\x20\x6d\x61\x73\x6b\x20\x27").$5).
"\x27\x2e"));($interfaces{$1}={"\x69\x70",$4,"\x6d\x61\x73\x6b",$5});}}return (
%interfaces);}sub NXClusterTools::getClusterPublicKey{package NXClusterTools;no 
warnings;(my $file=NXPaths::getClusterRSAPublicKey ());if ((not (
Common::NXFile::isExists ($file)))){generateClusterKeys ();}(my $content=
Common::NXFile::getFileContent ($file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x3a\x20".$file));
Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::__setDatabaseBackup{package NXClusterTools;no warnings;(my $database
=shift (@_));(my $content=shift (@_));if (($content ne (""))){NXRedis::sendToDb 
(((((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x65\x74\x6e\x78\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x62\x61\x63\x6b\x75\x70\x2e"
.$database)."\x2c\x76\x61\x6c\x75\x65\x3d").main::urlencode ($content))."\x0a"))
;}}sub NXClusterTools::getNodesDB{package NXClusterTools;no warnings;
main::nxrequire ("\x4e\x58\x4e\x6f\x64\x65\x73");return (
NXNodes::getDatabaseInString ());}sub NXClusterTools::getClusterDB{package 
NXClusterTools;no warnings;return (getDatabaseInString ());}sub 
NXClusterTools::getProfilesDB{package NXClusterTools;no warnings;main::nxrequire
 ("\x4e\x58\x50\x72\x6f\x66\x69\x6c\x65\x73\x44\x42");return (
NXProfilesDB::getDatabaseInString ());}sub NXClusterTools::getUsersDB{package 
NXClusterTools;no warnings;main::nxrequire (
"\x4e\x58\x55\x73\x65\x72\x73\x4d\x61\x6e\x61\x67\x65\x72");return (
NXUsersManager::getDatabaseInString ());}sub NXClusterTools::getAdministratorsDB
{package NXClusterTools;no warnings;main::nxrequire (
"\x4e\x58\x41\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73\x4d\x61\x6e\x61\x67\x65\x72"
);return (NXAdministratorsManager::getDatabaseInString ());}sub 
NXClusterTools::getGroupsDB{package NXClusterTools;no warnings;main::nxrequire (
"\x4e\x58\x47\x72\x6f\x75\x70\x73");return (NXGroups::getDatabaseInString ());}
sub NXClusterTools::getNXCerts{package NXClusterTools;no warnings;
main::nxrequire ("\x4e\x58\x53\x65\x72\x76\x65\x72\x73");return (
NXServers::getNXCertsString ());}sub NXClusterTools::getSSHCerts{package 
NXClusterTools;no warnings;main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x65\x72\x73");return (NXServers::getSSHCertsString ())
;}sub NXClusterTools::getNetworkDB{package NXClusterTools;no warnings;return (
Common::NXFile::getFileContent (NXPaths::getNetworkDB ()));}sub 
NXClusterTools::getNetworkFile{package NXClusterTools;no warnings;return (
Common::NXFile::getFileContent (NXPaths::getNetworkFile ()));}sub 
NXClusterTools::getServerDSAPublicKey{package NXClusterTools;no warnings;(my $file
=NXPaths::getServerDSAPublicKey ());if ((not (Common::NXFile::isExists ($file)))
){return ((""));}return (Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::getServerDSAPrivateKey{package NXClusterTools;no warnings;(my $file
=NXPaths::getServerDSAPrivateKey ());if ((not (Common::NXFile::isExists ($file))
)){return ((""));}return (Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::getServerRSAPublicKey{package NXClusterTools;no warnings;(my $file
=NXPaths::getServerRSAPublicKey ());if ((not (Common::NXFile::isExists ($file)))
){return ((""));}return (Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::getServerRSAPrivateKey{package NXClusterTools;no warnings;(my $file
=NXPaths::getServerRSAPrivateKey ());if ((not (Common::NXFile::isExists ($file))
)){return ((""));}return (Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::getPlayerCerts{package NXClusterTools;no warnings;(my $file=
NXPaths::getUserNXKnownCerts ());(my $content=Common::NXFile::getFileContent (
$file));return ($content);}sub NXClusterTools::getHostPrivateCert{package 
NXClusterTools;no warnings;(my $file=NXPaths::getHostPrivateCert ());(my $content
=Common::NXFile::getFileContent ($file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return (main::urlencode (
$content));}sub NXClusterTools::getHostPublicCert{package NXClusterTools;no 
warnings;(my $file=NXPaths::getHostPublicCert ());(my $content=
Common::NXFile::getFileContent ($file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::getClusterMasterCertPub{package NXClusterTools;no warnings;(my $file
=NXPaths::getClusterHostPublicCert ());if ((not (Common::NXFile::isExists ($file
)))){generateClusterHostCerts ();}(my $content=Common::NXFile::getFileContent (
$file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::getClusterMasterCertPriv{package NXClusterTools;no warnings;(my $file
=NXPaths::getClustetHostPrivateCert ());if ((not (Common::NXFile::isExists (
$file)))){generateClusterHostCerts ();}(my $content=
Common::NXFile::getFileContent ($file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::getSSHHostKeyDSAPrivate{package NXClusterTools;no warnings;(my $file
=NXPaths::getSSHHostKeyDSAPrivate ());(my $content=
Common::NXFile::getFileContent ($file));return ($content);}sub 
NXClusterTools::getSSHHostKeyDSAPublic{package NXClusterTools;no warnings;(my $file
=NXPaths::getSSHHostKeyDSAPublic ());(my $content=Common::NXFile::getFileContent
 ($file));return ($content);}sub NXClusterTools::getSSHHostKeyRSAPrivate{package
 NXClusterTools;no warnings;(my $file=NXPaths::getSSHHostKeyRSAPrivate ());(my $content
=Common::NXFile::getFileContent ($file));return ($content);}sub 
NXClusterTools::getSSHHostKeyRSAPublic{package NXClusterTools;no warnings;(my $file
=NXPaths::getSSHHostKeyRSAPublic ());(my $content=Common::NXFile::getFileContent
 ($file));return ($content);}sub NXClusterTools::getUserKnownHostsSSH{package 
NXClusterTools;no warnings;return (Common::NXFile::getFileContent (
NXPaths::getUserKnownHostsSSH ()));}sub NXClusterTools::__unsync{package 
NXClusterTools;no warnings;(my $file=shift (@_));(my $owner=shift (@_));(my $fileBackup
=($file."\x2e\x62\x61\x63\x6b\x75\x70"));if (Common::NXFile::isExists (
$fileBackup)){Logger::debug ((((("\x52\x65\x6e\x61\x6d\x65\x20\x27".$fileBackup)
."\x27\x20\x74\x6f\x20\x27").$file)."\x27\x2e"));unless (rename ($fileBackup,
$file)){Logger::error ((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6e\x61\x6d\x65\x20\x66\x69\x6c\x65\x20\x27"
.$fileBackup)."\x27\x20\x74\x6f\x20\x27").$file)."\x27\x2e\x20").$!));return (
(0x16c9+ 1667-0x1d4b));}if (($owner ne "\x72\x6f\x6f\x74")){
changeFileOwnershipToNxIfRoot ($file);}}return ((0x161b+ 113-0x168c));}sub 
NXClusterTools::__unsyncDatabases{package NXClusterTools;no warnings;if (
__isDatabaseBackupExist ("\x6e\x6f\x64\x65\x73")){main::nxrequire (
"\x4e\x58\x4e\x6f\x64\x65\x73");NXNodes::cleanDb ();NXNodes::setDatabaseByString
 (__getDatabaseBackup ("\x6e\x6f\x64\x65\x73"));}if (__isDatabaseBackupExist (
"\x70\x72\x6f\x66\x69\x6c\x65\x73")){main::nxrequire (
"\x4e\x58\x50\x72\x6f\x66\x69\x6c\x65\x73\x44\x42");NXProfilesDB::cleanDb ();
NXProfilesDB::setDatabaseByString (__getDatabaseBackup (
"\x70\x72\x6f\x66\x69\x6c\x65\x73"));}if (__isDatabaseBackupExist (
"\x75\x73\x65\x72\x73")){main::nxrequire (
"\x4e\x58\x55\x73\x65\x72\x73\x4d\x61\x6e\x61\x67\x65\x72");
NXUsersManager::cleanDb ();NXUsersManager::setDatabaseByString (
__getDatabaseBackup ("\x75\x73\x65\x72\x73"));}if (__isDatabaseBackupExist (
"\x61\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73")){main::nxrequire (
"\x4e\x58\x41\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73\x4d\x61\x6e\x61\x67\x65\x72"
);NXAdministratorsManager::cleanDb ();
NXAdministratorsManager::setDatabaseByString (__getDatabaseBackup (
"\x61\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73"));}if (
__isDatabaseBackupExist ("\x63\x65\x72\x74\x73\x4e\x58")){main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x65\x72\x73");NXServers::setNXCertsByString (
__getDatabaseBackup ("\x63\x65\x72\x74\x73\x4e\x58"));}if (
__isDatabaseBackupExist ("\x63\x65\x72\x74\x73\x53\x53\x48")){main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x65\x72\x73");NXServers::setSSHCertsByString (
__getDatabaseBackup ("\x63\x65\x72\x74\x73\x53\x53\x48"));}if (
__isDatabaseBackupExist ("\x67\x72\x6f\x75\x70\x73")){main::nxrequire (
"\x4e\x58\x47\x72\x6f\x75\x70\x73");NXGroups::cleanDb ();
NXGroups::setDatabaseByString (__getDatabaseBackup ("\x67\x72\x6f\x75\x70\x73"))
;}}sub NXClusterTools::__isDatabaseBackupExist{package NXClusterTools;no 
warnings;(my $database=shift (@_));NXRedis::sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x65\x78\x69\x73\x74\x73\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x62\x61\x63\x6b\x75\x70\x2e"
.$database)."\x0a"));return (NXRedis::get ());}sub 
NXClusterTools::__getDatabaseBackup{package NXClusterTools;no warnings;(my $database
=shift (@_));NXRedis::sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x67\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x62\x61\x63\x6b\x75\x70\x2e"
.$database)."\x0a"));return (main::urldecode (NXRedis::get ()));}sub 
NXClusterTools::__remove{package NXClusterTools;no warnings;(my $file=shift (@_)
);if (Common::NXFile::isExists ($file)){Logger::debug (((
"\x52\x65\x6d\x6f\x76\x69\x6e\x67\x20\x5b".$file)."\x5d"));if ((not (unlink (
$file)))){Logger::error ((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6d\x6f\x76\x65\x20\x66\x69\x6c\x65\x20".
$file)."\x20").$!));}}}sub NXClusterTools::unsynchronize{package NXClusterTools;
no warnings;(my $host=shift (@_));__unsync (NXPaths::getUserNXKnownCerts ());
__unsync (NXPaths::getNXAuthorizedKeysPath ("\x6e\x78"));__unsync (
NXPaths::getNodePublicKeys ());if ((
Common::NXFile::setOwnerShipAndPermissionsReadOnlyForNX (
NXPaths::getNodePublicKeys ())==(-(0x0dea+ 4417-0x1f2a)))){Logger::error ((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x66\x69\x6c\x65\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x66\x6f\x72\x3a\x20"
.NXPaths::getNodePublicKeys ()));}__unsync (NXPaths::getUserKnownHostsSSH ());
__unsyncDatabases ();__remove (NXPaths::getClusterHostPublicCert ());__remove (
NXPaths::getClustetHostPrivateCert ());if (($host ne "\x6c\x6f\x63\x61\x6c")){
cleanDb ();}__unsync (NXPaths::getNetworkFile ());__unsync (
NXPaths::getNetworkDB ());}sub NXClusterTools::cleanSSHKeys{package 
NXClusterTools;no warnings;__unsync (NXPaths::getSSHHostKeyDSAPrivate (),
"\x72\x6f\x6f\x74");__unsync (NXPaths::getSSHHostKeyDSAPublic (),
"\x72\x6f\x6f\x74");__unsync (NXPaths::getSSHHostKeyRSAPrivate (),
"\x72\x6f\x6f\x74");__unsync (NXPaths::getSSHHostKeyRSAPublic (),
"\x72\x6f\x6f\x74");}sub NXClusterTools::addClusterKey{package NXClusterTools;no
 warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getNXAuthorizedKeysPath ("\x6e\x78"));(my $rights=
$NXBits::UserReadWrite);return (__appendFile ($file,$rights,$fileContent,
(0x1fdd+ 1361-0x23ae)));}sub NXClusterTools::setNodesDB{package NXClusterTools;
no warnings;(my $fileContent=shift (@_));main::nxrequire (
"\x4e\x58\x4e\x6f\x64\x65\x73");__setDatabaseBackup ("\x6e\x6f\x64\x65\x73",
NXNodes::getDatabaseInString ());NXNodes::cleanDb ();return (
NXNodes::setDatabaseByString ($fileContent));}sub NXClusterTools::setClusterDB{
package NXClusterTools;no warnings;(my $fileContent=shift (@_));cleanDb ();
return (setDatabaseByString ($fileContent));}sub NXClusterTools::setProfilesDB{
package NXClusterTools;no warnings;(my $fileContent=shift (@_));main::nxrequire 
("\x4e\x58\x50\x72\x6f\x66\x69\x6c\x65\x73\x44\x42");__setDatabaseBackup (
"\x70\x72\x6f\x66\x69\x6c\x65\x73",NXProfilesDB::getDatabaseInString ());
NXProfilesDB::cleanDb ();return (NXProfilesDB::setDatabaseByString ($fileContent
));}sub NXClusterTools::setUsersDB{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));main::nxrequire (
"\x4e\x58\x55\x73\x65\x72\x73\x4d\x61\x6e\x61\x67\x65\x72");__setDatabaseBackup 
("\x75\x73\x65\x72\x73",NXUsersManager::getDatabaseInString ());
NXUsersManager::cleanDb ();return (NXUsersManager::setDatabaseByString (
$fileContent));}sub NXClusterTools::setAdministratorsDB{package NXClusterTools;
no warnings;(my $fileContent=shift (@_));main::nxrequire (
"\x4e\x58\x41\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73\x4d\x61\x6e\x61\x67\x65\x72"
);__setDatabaseBackup (
"\x61\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73",
NXAdministratorsManager::getDatabaseInString ());
NXAdministratorsManager::cleanDb ();return (
NXAdministratorsManager::setDatabaseByString ($fileContent));}sub 
NXClusterTools::setGroupsDB{package NXClusterTools;no warnings;(my $fileContent=
shift (@_));main::nxrequire ("\x4e\x58\x47\x72\x6f\x75\x70\x73");
__setDatabaseBackup ("\x67\x72\x6f\x75\x70\x73",NXGroups::getDatabaseInString ()
);NXGroups::cleanDb ();return (NXGroups::setDatabaseByString ($fileContent));}
sub NXClusterTools::setNXCertsDB{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));main::nxrequire ("\x4e\x58\x53\x65\x72\x76\x65\x72\x73");
__setDatabaseBackup ("\x63\x65\x72\x74\x73\x4e\x58",NXServers::getNXCertsString 
());return (NXServers::setNXCertsByString ($fileContent));}sub 
NXClusterTools::setSSHCertsDB{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));main::nxrequire ("\x4e\x58\x53\x65\x72\x76\x65\x72\x73");
__setDatabaseBackup ("\x63\x65\x72\x74\x73\x53\x53\x48",
NXServers::getSSHCertsString ());return (NXServers::setSSHCertsByString (
$fileContent));}sub NXClusterTools::setNetworkDB{package NXClusterTools;no 
warnings;(my $fileContent=shift (@_));(my $file=NXPaths::getNetworkDB ());(my $rights
=$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x0d25+ 2358-0x14db)));}sub NXClusterTools::setNetworkFile{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getNetworkFile ());(my $rights=(($NXBits::UserReadWrite+
$NXBits::GroupRead)+$NXBits::OthersRead));return (__setFile ($file,$rights,
$fileContent,(0x183b+ 693-0x194c)));}sub NXClusterTools::setServerDSAPublicKey{
package NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getServerDSAPublicKey ());(my $rights=(($NXBits::UserReadWrite+
$NXBits::GroupRead)+$NXBits::OthersRead));return (__setFile ($file,$rights,
$fileContent,(0x17fb+ 2471-0x1ffe)));}sub NXClusterTools::setServerDSAPrivateKey
{package NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getServerDSAPrivateKey ());(my $rights=$NXBits::UserReadWrite);return (
__setFile ($file,$rights,$fileContent,(0x1a36+ 2734-0x2364)));}sub 
NXClusterTools::setServerRSAPublicKey{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getServerRSAPublicKey ());(my $rights=((
$NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead));return (
__setFile ($file,$rights,$fileContent,(0x1a53+ 228-0x1993)));}sub 
NXClusterTools::setServerRSAPrivateKey{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getServerRSAPrivateKey ());(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x0f19+ 2863-0x18c8)));}sub NXClusterTools::setClientCerts{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getUserNXKnownCerts ());(my $rights=$NXBits::UserReadWrite);return (
__setFile ($file,$rights,$fileContent,(0x194f+ 2382-0x211d)));}sub 
NXClusterTools::setAuthorizedCerts{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getNXAuthorizedKeysPath ("\x6e\x78"));(my $rights
=$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x12a5+ 3529-0x1eee)));}sub NXClusterTools::setSSHAuthorizedCerts{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getNodePublicKeys ());(my $rights=$NXBits::UserReadWrite);return (
__setFile ($file,$rights,$fileContent,(0x115f+ 1489-0x15b0)));}sub 
NXClusterTools::addSSHAuthorizedCerts{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getNodePublicKeys ());if (
Common::NXFile::isExists ($file)){my ($error);if ((
Common::NXFile::setPermissionsReadWriteForNX ($file,(\$error))==(-
(0x091b+ 1477-0x0edf)))){Logger::error (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x68\x61\x6e\x67\x65\x20\x72\x69\x67\x68\x74\x73\x20\x74\x6f\x20\x27"
.$file)."\x27\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$error).
"\x27\x2e"));return ((0x0b03+ 2101-0x1337));}}(my $rights=$NXBits::UserReadWrite
);return (__appendFile ($file,$rights,$fileContent,(0x22d3+ 173-0x2200)));}sub 
NXClusterTools::__setHostPrivateCert{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getHostPrivateCert ());(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x0d44+ 394-0x0d4e)));}sub NXClusterTools::__setHostPublicCert{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getHostPublicCert ());(my $rights=$NXBits::UserReadWrite);return (
__setFile ($file,$rights,$fileContent,(0x1d57+ 2485-0x258c)));}sub 
NXClusterTools::setClusterMasterCertPub{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getClusterHostPublicCert ());(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x082f+ 5543-0x1c56)));}sub NXClusterTools::setClusterMasterCertPriv{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getClustetHostPrivateCert ());(my $rights=$NXBits::UserReadWrite);
return (__setFile ($file,$rights,$fileContent,(0x068f+ 3871-0x142e)));}sub 
NXClusterTools::setKnownHostsSSH{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getUserKnownHostsSSH ());(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x01d8+ 3313-0x0d49)));}sub NXClusterTools::setSSHHostKeyDSAPrivate{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getSSHHostKeyDSAPrivate ());(my $rights=$NXBits::UserReadWrite);
__setFile ($file,$rights,$fileContent,(0x223f+ 1162-0x2549),"\x72\x6f\x6f\x74");
return ((0x1326+ 4315-0x2401));}sub NXClusterTools::setSSHHostKeyDSAPublic{
package NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getSSHHostKeyDSAPublic ());(my $rights=(($NXBits::UserReadWrite+
$NXBits::GroupRead)+$NXBits::OthersRead));__setFile ($file,$rights,$fileContent,
(0x0edf+ 4580-0x1f1f),"\x72\x6f\x6f\x74");return ((0x0bff+ 2692-0x1683));}sub 
NXClusterTools::setSSHHostKeyRSAPrivate{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getSSHHostKeyRSAPrivate ());(my $rights=
$NXBits::UserReadWrite);__setFile ($file,$rights,$fileContent,
(0x099c+ 6524-0x2198),"\x72\x6f\x6f\x74");return ((0x1f74+ 794-0x228e));}sub 
NXClusterTools::setSSHHostKeyRSAPublic{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getSSHHostKeyRSAPublic ());(my $rights=((
$NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead));__setFile (
$file,$rights,$fileContent,(0x0a21+ 5726-0x1edb),"\x72\x6f\x6f\x74");return (
(0x0833+ 2061-0x1040));}sub NXClusterTools::__backupPrevious{package 
NXClusterTools;no warnings;(my $original=shift (@_));(my $rights=shift (@_));(my $owner
=shift (@_));unless (Common::NXFile::fileExists ($original)){return (
(0x1c29+ 2536-0x2611));}(my $backup=($original."\x2e\x62\x61\x63\x6b\x75\x70"));
if (Common::NXFile::fileExists ($backup)){($backup.=("\x2d".NXTools::getTimeMs 
()));}(my ($retValue,$outMsg)=Common::NXCore::copyFile ($original,$backup));if (
($outMsg ne (""))){Logger::error (((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x70\x79\x20\x27".$original).
"\x27\x20\x74\x6f\x20\x27").$backup).
"\x27\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$outMsg)."\x27\x2e"));
return ((0x069d+ 8021-0x25f1));}my ($error);if ((Common::NXFile::setPermission (
$backup,$rights,(\$error))==(-(0x1048+ 4055-0x201e)))){Logger::warning (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x68\x61\x6e\x67\x65\x20\x72\x69\x67\x68\x74\x73\x20\x74\x6f\x20"
.$backup)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$error)."\x27\x2e"
));return ((0x114d+ 3094-0x1d62));}unless (Common::NXFile::fileExists ($backup))
{Logger::error (((((
"\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x63\x72\x65\x61\x74\x65\x20\x66\x69\x6c\x65\x20\x62\x61\x63\x6b\x75\x70\x20\x27"
.$backup)."\x27\x20\x66\x6f\x72\x20\x27").$original)."\x27\x2e"));return (
(0x2233+ 219-0x230d));}if (($owner ne "\x72\x6f\x6f\x74")){
changeFileOwnershipToNxIfRoot ($backup);}return ((0x1525+ 4093-0x2522));}sub 
NXClusterTools::__setFile{package NXClusterTools;no warnings;(my $file=shift (@_
));(my $rights=shift (@_));(my $fileBody=shift (@_));(my $backupRights=shift (@_
));(my $backupOwner=shift (@_));if (__backupPrevious ($file,$backupRights,
$backupOwner)){return ((0x0665+ 2885-0x11a9));}(my $fileBackup=($file.
"\x2e\x74\x6d\x70"));(my $fileDesc=main::nxopen ($fileBackup,($NXBits::O_WRONLY+
$NXBits::O_CREAT),$rights));unless (defined ($fileDesc)){Logger::error (((
"\x45\x72\x72\x6f\x72\x20\x6f\x70\x65\x6e\x69\x6e\x67\x20\x66\x69\x6c\x65\x20\x27"
.$fileBackup)."\x27\x2e"));return ((0x25e5+  66-0x2626));}if ((main::nxwrite (
$fileDesc,$fileBody)==(-(0x1470+ 1622-0x1ac5)))){(my $errorNumber=
libnxh::NXGetError ());(my $errorstring=libnxh::NXGetErrorString ());
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20\x27"
.$fileBackup)."\x27\x2e"));Logger::error (((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20".$errorNumber)."\x2c\x20").
$errorstring)."\x2e"));main::nxclose ($fileDesc);if (($backupOwner ne 
"\x72\x6f\x6f\x74")){changeFileOwnershipToNxIfRoot ($fileBackup);}return (
(0x086f+ 7362-0x2530));}main::nxclose ($fileDesc);if (($backupOwner ne 
"\x72\x6f\x6f\x74")){changeFileOwnershipToNxIfRoot ($fileBackup);}unless (rename
 ($fileBackup,$file)){Logger::error (((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6e\x61\x6d\x65\x20\x66\x69\x6c\x65\x20\x27"
.$fileBackup)."\x27\x20\x74\x6f\x20\x27").$file).
"\x27\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$!)."\x27\x2e"));return 
((0x00f0+ 9359-0x257e));}return ((0x084a+  56-0x0882));}sub 
NXClusterTools::__appendFile{package NXClusterTools;no warnings;(my $file=shift 
(@_));(my $rights=shift (@_));(my $fileBody=shift (@_));(my $rightBackup=shift (
@_));(my $ownerBackup=shift (@_));if (__backupPrevious ($file,$rightBackup,
$ownerBackup)){return ((0x0ae7+ 977-0x0eb7));}(my $fileExisted=
(0x0bd3+ 5529-0x216c));if (Common::NXFile::isExists ($file)){($fileExisted=
(0x1a71+ 1871-0x21bf));}(my $fileDesc=main::nxopen ($file,(($NXBits::O_WRONLY+
$NXBits::O_CREAT)+$NXBits::O_APPEND),$rights));unless (defined ($fileDesc)){
Logger::error (((
"\x45\x72\x72\x6f\x72\x20\x77\x68\x69\x6c\x65\x20\x6f\x70\x65\x6e\x69\x6e\x67\x20\x66\x69\x6c\x65\x20\x27"
.$file)."\x27\x20\x74\x6f\x20\x61\x70\x70\x65\x6e\x64\x2e"));return (
(0x17c4+ 1955-0x1f66));}if ((main::nxwrite ($fileDesc,$fileBody)==(-
(0x0466+ 3371-0x1190)))){(my $errorNumber=libnxh::NXGetError ());(my $errorstring
=libnxh::NXGetErrorString ());Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20"
.$file)."\x2e"));Logger::error ((((("\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20".
$errorNumber)."\x2c\x20").$errorstring)."\x2e"));main::nxclose ($fileDesc);if ((
not ($fileExisted))){if (($ownerBackup ne "\x72\x6f\x6f\x74")){
changeFileOwnershipToNxIfRoot ($file);}}return ((0x15a2+ 417-0x1742));}
main::nxclose ($fileDesc);if ((not ($fileExisted))){
changeFileOwnershipToNxIfRoot ($file);}return ((0x17fb+ 3552-0x25db));}sub 
NXClusterTools::__addClusterNodeKey{package NXClusterTools;no warnings;(my $message
=shift (@_));($message=main::urldecode ($message));return (addClusterKey (
$message));}sub NXClusterTools::checkUserNXConfigDir{package NXClusterTools;no 
warnings;(my $path=NXPaths::getConfigDir ());unless (Common::NXFile::isExists (
$path)){my ($error);unless (Common::NXPaths::createAccessibleForNXDirectory ((
\$error),$path)){return ((0x081d+ 5385-0x1d26));}}return ((0x0c76+ 5637-0x227a))
;}sub NXClusterTools::isItMyIP{package NXClusterTools;no warnings;(my $IPtoCheck
=shift (@_));Logger::debug (((
"\x43\x68\x65\x63\x6b\x20\x69\x73\x20\x6d\x79\x20\x49\x50\x20\x5b".$IPtoCheck).
"\x5d"));if ((not (defined ($IPtoCheck)))){return ((0x1483+ 1570-0x1aa5));}(my (
%interfaces)=getInterfaces ());foreach my $name (keys (%interfaces)){
Logger::debug ((((("\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x5b".$name).
"\x5d\x20\x69\x70\x20\x5b").$interfaces{$name}{"\x69\x70"})."\x5d"));if ((
$interfaces{$name}{"\x69\x70"}eq $IPtoCheck)){return ((0x1d41+ 2074-0x255a));}}
return ((0x1401+ 398-0x158f));}sub NXClusterTools::prepareNXKnownCerts{package 
NXClusterTools;no warnings;(my $refClusterHash=shift (@_));my ($file);foreach my $key
 (keys (%$refClusterHash)){(my $value=$$refClusterHash{$key});chomp ($value);if 
(Common::NXShellCreate::isHostInCertFile ($key,NXPaths::getCurrentUserKnownCerts
 ())){Common::NXShellCreate::removeCertificate ($key,$value,
NXPaths::getUserNXKnownCerts ());}($file.=(((("\x48\x6f\x73\x74\x3a".$key).
"\x0a").$value)."\x0a"));}(my $myIp=$GLOBAL::ClusterOldLocal);(my $myCert=
getHostPublicCert ());chomp ($myCert);if (
Common::NXShellCreate::isHostInCertFile ($myIp,NXPaths::getCurrentUserKnownCerts
 ())){Common::NXShellCreate::removeCertificate ($myIp,$myCert,
NXPaths::getUserNXKnownCerts ());}($file.=(((("\x48\x6f\x73\x74\x3a".$myIp).
"\x0a").$myCert)."\x0a"));(my $hostCert=getClusterMasterCertPub ());chomp (
$hostCert);if (Common::NXShellCreate::isHostInCertFile ($GLOBAL::ClusterHost,
NXPaths::getCurrentUserKnownCerts ())){Common::NXShellCreate::removeCertificate 
($GLOBAL::ClusterHost,$hostCert,NXPaths::getUserNXKnownCerts ());}($file.=((((
"\x48\x6f\x73\x74\x3a".$GLOBAL::ClusterHost)."\x0a").$hostCert)."\x0a"));($file
.=getPlayerCerts ());setClientCerts ($file);(my $path=
NXPaths::getUserNXKnownCerts ());changeFileOwnershipToNxIfRoot ($path);return (
$file);}sub NXClusterTools::__preparePublicKeys{package NXClusterTools;no 
warnings;(my $ref_publicKeys=shift (@_));(my $protocol=shift (@_));(my $file=
(""));my ($filePath);if (($protocol eq "\x53\x53\x48")){($filePath=
NXPaths::getNodePublicKeys ());}else{($filePath=NXPaths::getNXAuthorizedKeysPath
 ("\x6e\x78"));}(my $fileContent=Common::NXFile::getFileContent ($filePath));(my (
@oldContent)=split ( /\n/ ,$fileContent,(0x0c1b+ 691-0x0ece)));(my $prefix=
"\x6e\x6f\x2d\x70\x6f\x72\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c\x6e\x6f\x2d\x61\x67\x65\x6e\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c"
);($prefix.=(("\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x22".$GLOBAL::ETC_DIR).
$GLOBAL::DIRECTORY_SLASH));($prefix.=
"\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x72\x65\x6d\x6f\x74\x65\x6c\x6f\x67\x69\x6e\x22\x20"
);foreach my $key (keys (%$ref_publicKeys)){(my $potentialKey=$$ref_publicKeys{
$key});(my $add=(0x03ad+ 3097-0x0fc5));chomp ($potentialKey);($potentialKey=~ s/\r//g )
;if (($protocol eq "\x53\x53\x48")){($potentialKey=($prefix.$potentialKey));}
foreach my $line (@oldContent){chomp ($line);($line=~ s/\r//g );if ((
$potentialKey eq $line)){($add=(0x12c8+ 2743-0x1d7f));last;}}if (($add==
(0x0b51+ 1370-0x10aa))){($file.=($potentialKey."\x0a"));}}(my $potentialKey=
getClusterPublicKey ());chomp ($potentialKey);($potentialKey=~ s/\r//g );if ((
$protocol eq "\x53\x53\x48")){($potentialKey=($prefix.$potentialKey));}(my $add=
(0x0109+ 7698-0x1f1a));foreach my $line (@oldContent){chomp ($line);($line=~ s/\r//g )
;if (($potentialKey eq $line)){($add=(0x057a+ 5099-0x1965));last;}}if (($add==
(0x0f44+ 329-0x108c))){($file.=($potentialKey."\x0a"));}($file.=$fileContent);if
 (($protocol eq "\x53\x53\x48")){setSSHAuthorizedCerts ($file);}else{
setAuthorizedCerts ($file);}return ($file);}sub 
NXClusterTools::prepareNXDPublicKeys{package NXClusterTools;no warnings;(my $ref_publicKeys
=shift (@_));return (__preparePublicKeys ($ref_publicKeys,"\x4e\x58"));}sub 
NXClusterTools::prepareSSHPublicKeys{package NXClusterTools;no warnings;(my $ref_publicKeys
=shift (@_));return (__preparePublicKeys ($ref_publicKeys,"\x53\x53\x48"));}sub 
NXClusterTools::prepareSSHClusterKey{package NXClusterTools;no warnings;(my $prefix
=
"\x6e\x6f\x2d\x70\x6f\x72\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c\x6e\x6f\x2d\x61\x67\x65\x6e\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c"
);($prefix.=((("\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x22".$GLOBAL::ETC_DIR).
$GLOBAL::DIRECTORY_SLASH).
"\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x72\x65\x6d\x6f\x74\x65\x6c\x6f\x67\x69\x6e\x22\x20"
));(my $key=($prefix.getClusterPublicKey ()));return ($key);}sub 
NXClusterTools::prepareKnownHostsSSH{package NXClusterTools;no warnings;(my $host
=shift (@_));(my $sshCrt=shift (@_));($sshCrt=~ s/\015//gs );my ($file);if ((
$sshCrt ne (""))){($file=(((($GLOBAL::ClusterPool."\x2c").$GLOBAL::ClusterHost).
"\x20").$sshCrt));}Common::NXShellCreate::removeCertificateSSH (
$GLOBAL::ClusterHost,(""),NXPaths::getUserKnownHostsSSH ());(my (@hosts)=split ( /,/ ,
$GLOBAL::ClusterPool,(0x12b2+ 4251-0x234d)));foreach my $host (@hosts){
Common::NXShellCreate::removeCertificateSSH ($host,(""),
NXPaths::getUserKnownHostsSSH ());}($file.=getUserKnownHostsSSH ());
setKnownHostsSSH ($file);return ($file);}sub NXClusterTools::checkKeys{package 
NXClusterTools;no warnings;if ((not (Common::NXFile::isExists (
NXPaths::getClusterRSAPrivateKey ())))){generateClusterKeys ();}if ((not (
Common::NXFile::isExists (NXPaths::getClusterRSAPublicKey ())))){
generateClusterKeys ();}if ((not (Common::NXFile::isExists (
NXPaths::getClusterHostPublicCert ())))){generateClusterHostCerts ();}if ((not (
Common::NXFile::isExists (NXPaths::getClustetHostPrivateCert ())))){
generateClusterHostCerts ();}}sub NXClusterTools::changeFileOwnershipToNxIfRoot{
package NXClusterTools;no warnings;(my $file=shift (@_));(my $user=
Common::NXCore::getEffectiveUsername ());if (($user eq "\x72\x6f\x6f\x74")){
Logger::debug2 (((
"\x53\x65\x74\x74\x69\x6e\x67\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x6f\x72\x20\x75\x73\x65\x72\x20\x6e\x78\x2c\x20"
.$file)."\x2e"));my ($errorName);my ($errorCode);if ((
Common::NXFile::setOwnershipForUserSilent ($file,"\x6e\x78",(\$errorName),(
\$errorCode))==(-(0x002b+ 7799-0x1ea1)))){Logger::error ((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x69\x6c\x65\x20"
.$file)."\x2e\x20").$errorCode)."\x20").$errorName));NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x53\x65\x74\x4f\x77\x6e\x65\x72\x73\x68\x69\x70",
"\x4e\x58\x53\x68\x65\x6c\x6c",(($file."\x2e\x20").$errorName));unlink ($file);
main::nxexit ((0x10a3+ 1050-0x14bd));}}return ((0x060f+ 1816-0x0d27));}sub 
NXClusterTools::__getPathToPublicKey{package NXClusterTools;no warnings;if (
__isRSAKeyAvailable ()){return (NXPaths::getClusterRSAPrivateKey ());}return (
NXPaths::getClusterDSAPrivateKey ());}sub NXClusterTools::getDatabaseInString{
package NXClusterTools;no warnings;(my $request=
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x67\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e\x63\x6f\x6e\x66\x69\x67\x2c\x66\x69\x65\x6c\x64\x3d\x6d\x61\x73\x74\x65\x72\x2c\x66\x69\x65\x6c\x64\x3d\x73\x68\x61\x72\x65\x64\x2c\x66\x69\x65\x6c\x64\x3d\x70\x72\x6f\x74\x6f\x2c\x66\x69\x65\x6c\x64\x3d\x67\x72\x61\x63\x65"
);($request.=
"\x2c\x66\x69\x65\x6c\x64\x3d\x72\x65\x74\x72\x79\x2c\x66\x69\x65\x6c\x64\x3d\x70\x72\x6f\x62\x65\x2c\x66\x69\x65\x6c\x64\x3d\x69\x6e\x74\x65\x72\x76\x61\x6c\x2c\x66\x69\x65\x6c\x64\x3d\x74\x69\x6d\x65\x6f\x75\x74\x2c\x66\x69\x65\x6c\x64\x3d\x6d\x61\x69\x6e\x43\x6c\x75\x73\x74\x65\x72\x55\x55\x49\x44\x2c\x66\x69\x65\x6c\x64\x3d\x63\x6c\x75\x73\x74\x65\x72\x47\x55\x49\x44\x0a"
);(my $databaseString=(""));NXRedis::sendToDb ($request);(my $config=
NXRedis::get ());($config=~ s/ /,/g );($databaseString.=($config."\x0a"));
NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x6d\x65\x6d\x62\x65\x72\x73\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x0a"
);(my $clusterList=NXRedis::get ());(my (@list)=split ( / / ,$clusterList,
(0x03c8+ 1889-0x0b29)));foreach $host (@list){NXRedis::sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x67\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e"
.$host).
"\x2c\x66\x69\x65\x6c\x64\x3d\x68\x6f\x73\x74\x2c\x66\x69\x65\x6c\x64\x3d\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x2c\x66\x69\x65\x6c\x64\x3d\x6e\x65\x74\x6d\x61\x73\x6b\x0a"
));(my $line=NXRedis::get ());($line=~ s/ /,/g );($databaseString.=($line."\x0a"
));}return ($databaseString);}sub NXClusterTools::setDatabaseByString{package 
NXClusterTools;no warnings;(my $string=shift (@_));(my (@clusterList)=split ( /\n/ ,
$string,(0x0d3a+ 3218-0x19cc)));(my $redisString=__setConfigLine ($clusterList[
(0x0122+ 3090-0x0d34)]));NXRedis::sendToDb ($redisString);(my ($host1data,
$host1set)=__setHostLineS ($clusterList[(0x07b0+ 2429-0x112c)]));
NXRedis::sendToDb ($host1data);NXRedis::sendToDb ($host1set);(my ($host2data,
$host2set)=__setHostLineS ($clusterList[(0x1378+ 2213-0x1c1b)]));
NXRedis::sendToDb ($host2data);NXRedis::sendToDb ($host2set);return (
(0x037f+ 8737-0x25a0));}sub NXClusterTools::__setConfigLine{package 
NXClusterTools;no warnings;(my $configLine=shift (@_));(my $record=
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x73\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e\x63\x6f\x6e\x66\x69\x67"
);(my (@options)=split ( /,/ ,$configLine,(0x1917+ 2141-0x2174)));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x6d\x61\x73\x74\x65\x72\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x08cd+ 6241-0x212e)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x73\x68\x61\x72\x65\x64\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x012c+ 1551-0x073a)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x70\x72\x6f\x74\x6f\x2c\x76\x61\x6c\x75\x65\x3d".
$options[(0x0c74+ 1446-0x1218)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x67\x72\x61\x63\x65\x2c\x76\x61\x6c\x75\x65\x3d".
$options[(0x13aa+ 2768-0x1e77)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x72\x65\x74\x72\x79\x2c\x76\x61\x6c\x75\x65\x3d".
$options[(0x0585+ 1017-0x097a)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x70\x72\x6f\x62\x65\x2c\x76\x61\x6c\x75\x65\x3d".
$options[(0x106d+ 5274-0x2502)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x69\x6e\x74\x65\x72\x76\x61\x6c\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x06fa+ 2539-0x10df)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x74\x69\x6d\x65\x6f\x75\x74\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x0009+ 1264-0x04f2)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x6d\x61\x69\x6e\x43\x6c\x75\x73\x74\x65\x72\x55\x55\x49\x44\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x0a63+ 6951-0x2582)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x63\x6c\x75\x73\x74\x65\x72\x47\x55\x49\x44\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x1c5a+ 541-0x1e6e)]));($record.="\x0a");return ($record);}sub 
NXClusterTools::__setHostLineS{package NXClusterTools;no warnings;(my $hostLine=
shift (@_));(my (@host)=split ( /,/ ,$hostLine,(0x11cf+ 550-0x13f5)));(my $record
=(
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x73\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e"
.$host[(0x0eaf+ 1826-0x15d1)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x68\x6f\x73\x74\x2c\x76\x61\x6c\x75\x65\x3d".$host
[(0x05cd+ 7394-0x22af)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x2c\x76\x61\x6c\x75\x65\x3d"
.$host[(0x1be0+ 2750-0x269d)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x6e\x65\x74\x6d\x61\x73\x6b\x2c\x76\x61\x6c\x75\x65\x3d"
.$host[(0x136b+ 1408-0x18e9)]));($record.="\x0a");(my $setRecord=((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x61\x64\x64\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2c\x66\x69\x65\x6c\x64\x3d"
.$host[(0x09f3+ 3859-0x1906)])."\x0a"));return ($record,$setRecord);}sub 
NXClusterTools::cleanDb{package NXClusterTools;no warnings;NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x6d\x65\x6d\x62\x65\x72\x73\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x0a"
);(my (@hosts)=split ( / / ,NXRedis::get (),(0x044f+ 7061-0x1fe4)));
NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x64\x65\x6c\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x0a"
);foreach my $host (@hosts){NXRedis::sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x64\x65\x6c\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e"
.$host)."\x0a"));}NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x64\x65\x6c\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e\x63\x6f\x6e\x66\x69\x67\x0a"
);return ((0x0987+ 6357-0x225c));}package NXClusterTools;no warnings;return (
(0x19c0+ 614-0x1c25));
